//SETUP
var PROTO_PATH = __dirname + '../../../protos/v3/projector.proto';
var assert = require('assert');
var async = require('async');
const axios = require('axios');
var _ = require('lodash');
var grpc = require('@grpc/grpc-js');
var protoLoader = require('@grpc/proto-loader');
const http = require("http");

var packageDefinition = protoLoader.loadSync(
    PROTO_PATH,
    {keepCase: true,
     longs: String,
     enums: String,
     defaults: true,
     oneofs: true
    });
var protoDescriptor = grpc.loadPackageDefinition(packageDefinition);
var projectorPackage = protoDescriptor.provee;

//OLD
function sendPoint(call, callback) {
  axios.get('http://localhost:8090/generatePoint').then(resp=>{
    callback(null, resp["data"]["point"]);
  })
}


//Route the grpc function to the microservice
function sendPointStream(call) {
  http.get("http://localhost:8090/generatePointStream", res =>{

    res.on("data", data =>{
      sendDataStream(data,call)
    })

    res.on("end",function() {
        call.end();
    })
  })  
}

//Right now it doesnt fix cut off jsons (FIX LATER)
function sendDataStream(data,call){
  var list = data.toString().split("\n")

  for(var i =1; i <list.length-2;i++){
      var response = JSON.parse(list[i]);
      call.write(response["point"]);
  }
}


//Create server and route the grpc functions to js functions
function getServer() {

  var server = new grpc.Server();
  server.addService(projectorPackage.Projector.service, {
    getProjectionPoints: sendPointStream,
  });
  console.log("started");
  return server;
}

//Setup
if (require.main === module) {
  var server = getServer();
  server.bindAsync(
    '0.0.0.0:9090', grpc.ServerCredentials.createInsecure(), (err, port) => {
      assert.ifError(err);
      server.start();
      console.log("connected");
  });
}
exports.getServer = getServer;
